<html>
<head>
	<title>Çoklu Sır Paylaşım Şeması</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge" />
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<script type="text/javascript" src="jquery-1.10.2.js"></script>
	<!--<link rel="stylesheet" type="text/css" href="bootstrap-3.3.7-dist/css/bootstrap.css">-->
	<!--<script type="text/javascript" src="bootstrap-3.3.7-dist/js/bootstrap.js"></script>-->

	<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
	<script type="text/javascript" src="calculationlib/ecclib.js"></script>
	<script type="text/javascript" src="calculationlib/polynomial.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
	<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
	<script type="text/x-mathjax-config">
		MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
		MathJax.Localization.setLocale("tr");
	</script>
	<script>
		
		rowCount = 1;
		var AddFormula = function(container, name, tex) {
			var containerSelector = $('#' + container);
			if ($('#' + name).length == 0)
				containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
			else $('#' + name).html("");

			$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
			MathJax.Hub.Queue(
				//function () { $('#' + name).css('visibility','hidden')
				["Typeset",MathJax.Hub]
				//,function () { $('#' + name).css('visibility','visible') }
			);
		}
		var AddAccessSetInput = function(tableId, count, rowId){
			var text = "<tr>";
			for (var i = 1; i < count+1; i++){
				text += "<td> <input type='checkbox' row='" + rowId + "' col='" + i + "' /> </td>"
			}
			text += "</tr>";
			$('#' + tableId + ' tr:last').after(text);
		}
		var CreateInput = function(inputCount, q) {

			var text = "<table>";

			text += "<tr>";
			for (var i = 1; i < inputCount+1; i++)
				text += "<td align='center'>" + i + "</td>";
			text += "</tr>";

			text += "<tr>";
			for (var i = 1; i < inputCount+1; i++)
				text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
			text += "</tr>";

			text += "</table>";
			return text;
		}	
		var ReadMatrix = function(text) {
				
			var data = [];
			text = text.replace( /\s\s+/g, ' ' );
			var lines = text.split(/\r|\n/);
			for (var i = 0; i < lines.length; i++) {
				var lineData = [];
				var cells = lines[i].split(' ');
				for (var j = 0; j < cells.length; j++) {
					if(cells[j] != "") {
						lineData.push(parseInt(cells[j]));
					}
				}
				if (lineData.length > 0)
					data.push(lineData);
			}
			return data;
		}
	</script>
</head>

<body>

	<h2>Çoklu Sır Paylaşım Şeması </h2>

	<h3>Sırı Oluşturma</h3>
	
	<table>
	
	<tr>
	<td> <label class="col-sm-2 control-label"><b>GF</b></label> </td>
	<td> <input type="text" id="txtDegree" value="2"/> </td> 
	</tr>
	
	<tr>
	<td> <label class="col-sm-2 control-label"><b>Kod</b></label> </td>
	<td> 
	<textarea class="form-control" id="txtGeneratorMatrix" rows="5">
1 0 1 0 1
0 1 0 1 1</textarea>
	</td>
	</tr>
	
	<tr>
	<td> <label class="col-sm-2 control-label"><b>Sır</b></label> </td>
	<td> <input type="text" id="txtSecret" value="1 0"/> </td> 
	</tr>
	
	<tr>
	<td> </td>
	<td> <input type="button" id="btnConstructSecret" value="Sırrı Oluştur" /> </td>
	</tr>
	
	</table>
	
	<div id="divConstSecretResult"></div>

	
	<hr />
	<h3>Sırrı Çözme</h3>
	
	<div id="divFindSecretParams">
		<b>q:</b> <input type='text' id='txtQ2' value='2'/> <br />
		<div id="divSecretInputs"></div>
		<input type='button' id='btnFindSecret' value='Sırrı Bul' />
	</div>
	<div id="divFindSecretResult"></div>

	<script type="text/javascript">
		
		$(document).ready(function () {
			$("input[type='button']").click(function (e) {
				if (e.target.id == "btnConstructSecret") {
					
					var factorial = function(a) { var v = 1; for (var i=1; i <= a; i++) v = v * i; return v; }
					var combination = function(n,k) { return factorial(n) / (factorial(n-k) * factorial(k)); }

						
					var q = parseInt($("#txtDegree").val());
					
					var text = $('#txtGeneratorMatrix').val();
					var arr = ReadMatrix(text);
					var generator = new Matrix(arr);
					var code = new ErrorCorrectingCode(generator, q);
					
					var text = $('#txtSecret').val();
					var arr = ReadMatrix(text);
					var secret = new CodeWord(new Matrix(arr));
					
					
					var processor = new MatrixCalculator(q);
					
					var minWeight = code.n;
					var weights = Array(code.n+1).fill(0);
					for (var i = 0; i < code.M; i++) {
						var word = code.GetWord(i)
						var codeWord = code.CalculateCodeword(word);
						weights[codeWord.weight] += 1;
						if (codeWord.weight != 0)
							minWeight = Math.min(minWeight, codeWord.weight);
					}
					weights = weights.reverse();
					
					var d = minWeight;
					var t = parseInt((minWeight - 1) / 2);
					
					$("#divConstSecretResult").html("");
					var info = "\\begin{eqnarray*}";
					info += "q&=&" + code.q + " \\\\";
					info += "n&=&" + code.n + " \\\\";
					info += "k&=&" + code.k + " \\\\";
					info += "M&=&" + code.M + " \\\\";
					info += "d&=&" + d + " \\\\";
					info += "t&=&" + t + " \\\\";
					info += "\\end{eqnarray*}";
					AddFormula("divConstSecretResult", "MathOutputInfo", info);
					$("#divConstSecretResult").append("<br />");
					
					
					var positions = [];
					while (positions.length < t) {
						var val = parseInt(Math.random() * (code.n));
						if (positions.indexOf(val) < 0)
							positions.push(val);
					}
					var hArray = Array(code.n).fill(0);
					for (var i = 0; i < positions.length; i++)
						hArray[positions[i]] = 1;
					var h = new Matrix(hArray);
					
					
					

					
					//var text = "\\begin{eqnarray*}";
					AddFormula("divConstSecretResult", "Secret1", "G=" + generator.ToLatex(true) );
					AddFormula("divConstSecretResult", "Secret2", "s=" + new Matrix(arr).ToLatex() );
					AddFormula("divConstSecretResult", "Secret3", "h=" + h.ToLatex() );
					//text += "\\end{eqnarray*}";
					//AddFormula("divConstSecretResult", "Secret", text);
					$("#divConstSecretResult").append("<br />");
					
					if (t < 1) {
						AddFormula("divConstSecretResult", "Hata", "Şemanın\\,çalışması\\,için\\,kodun\\,en\\,az\\,bir\\,hata\\,düzeltmesi\\,gerekir.");
						return;
					}
					
					if (code.k != new Matrix(arr).ColCount) {
						AddFormula("divConstSecretResult", "Hata", "Sırrın,\\,boyutu\\," + code.k + "\\,olmalıdır.");
						return;
					}
					
					
					var text = "\\begin{eqnarray*}";
					text += "C=\\{";
					for (var i = 0; i < code.M; i++) {
						var word = code.GetWord(i)
						var codeWord = code.CalculateCodeword(word);
						text += codeWord.Text;
						if (i != code.M-1)
							text += ",";
					}
					text += "\\}";
					text += "\\end{eqnarray*}";
					AddFormula("divConstSecretResult", "CodeWord", text);
					
					
					
					
					var dualCode = code.DualCode();
					
					// Cosets begin
					var getWord = function (k,q,i) {		
						var data = [];
						
						do {
							var r = i % q;
							i = parseInt(i / q); 
							data.push(r);
							if (i  < q)
								data.push(i);
						} while(i >= q)
						
						var dim = k - data.length;
						for (var j = 0; j < dim; j++) {
							data.push(0);
						}
						data = data.reverse();
						return new CodeWord(new Matrix(data));
					}
					
					var syndromeCount = Math.pow(code.q, code.n-code.k);
					var syndromeWords = {};
					for (var i = 0; i < syndromeCount; i++) {
						var word = getWord(code.n-code.k, code.q, i);
						syndromeWords[word.Text] = null; 
					}
					
					var allCount = Math.pow(code.q, code.n);
					for (var i = 0; i < allCount; i++) {
						var word = getWord(code.n, code.q, i);
						var synd = new CodeWord(processor.Multiply(word.Data, dualCode.Generator.Transpose()));
						var minWord = syndromeWords[synd.Text];
						if (minWord == null || word.weight < minWord.weight)
							syndromeWords[synd.Text] = word;
					}
					
					for (var i = 0; i < syndromeCount; i++) {
						var word = getWord(code.n-code.k, code.q, i);
						
						var cosetLeader = syndromeWords[word.Text];
						var text = cosetLeader.Text + " + C = \\{";
						for (var j = 0; j < code.M; j++) {
							
							var word = code.GetWord(j)
							var codeWord = code.CalculateCodeword(word);

							var cw = processor.Add(cosetLeader.Data, codeWord.Data);
							text += new CodeWord(cw).Text;
							if (j != code.M - 1)
								text += ", ";
						}
						text += "\\}";
						AddFormula("divConstSecretResult", "cw" + i, text);
					}
					
					
					// Cosets end
					$("#divConstSecretResult").append("<br />");

					
					
					var encoded = processor.Add(processor.Multiply(new Matrix(arr), generator), h);
					var encodedWord = new CodeWord(encoded);
					AddFormula("divConstSecretResult", "Encode1", "f(s)=sG+h");
					AddFormula("divConstSecretResult", "Encode2", "f(s)=" + new Matrix(arr).ToLatex() + generator.ToLatex() + "+" + h.ToLatex() );
					AddFormula("divConstSecretResult", "Encode3", "f(s)=" + encoded.ToLatex());
					$("#divConstSecretResult").append("<br />");

					
					// Ağırlık sayaçları
					
					var polynom = new Polynomial(weights, null, "z");
					var derrivative = new Polynomial(weights, null, "z");
					for (var i = 0; i < t; i++)
						derrivative = derrivative.Derivative(1);
						
					
					AddFormula("divConstSecretResult", "WeightCounter1", "A(z)=" + polynom.Text);
					AddFormula("divConstSecretResult", "WeightCounter2", "A" + "'".repeat(t) + "(z)=" + derrivative.Text);
					AddFormula("divConstSecretResult", "WeightCounter3", "A" + "'".repeat(t) + "(1)=" + derrivative.Calculate(1));
					$("#divConstSecretResult").append("<br />");
					
					// Ağırlık sayaçları son
					
					
					
					var positions = [];
					var der = derrivative.Data.reverse();
					for (var i = 0; i < der.length; i++) {
						if (der[i] != 0)
							positions.push(i);
					}
					
					var vectors = []
					for (var i = 0; i < Math.pow(code.q, code.n); i++) {
						var word = getWord(code.n, code.q, i);
						if (word.weight <= t && word.weight > 0)
							vectors.push(word);
					}
					
					for (var j = 0; j < code.M; j++) {
						var wrd = code.GetWord(j)
						var codeWord = code.CalculateCodeword(wrd);
						//if (codeWord.weight == 0)
						//	continue;
						
						var count = 0;
						var text = "c=" + codeWord.Text + ",\\quad "
						text += "c+h=\\{";
						for (var i = 0; i < vectors.length; i++) {
							var word = vectors[i];
							var cwd = new CodeWord(processor.Add(codeWord.Data, word.Data));
							if (positions.indexOf(cwd.weight) >= 0) {
								text += cwd.Text + ",";
								count++;
							}
						}
						
						text = text.substring(0, text.length-1);
						if (count == 0)
							text += " \\varnothing ";
						else 
							text += "\\}";
						AddFormula("divConstSecretResult", "MinimalSets" + j, text);
					}
					
					
					var shares = [];
					for (var i = 0; i < encoded.Data[0].length; i++) {
						share = "";
						var val = encoded.Get(0, i);
						share += "" + val;
						
						$("#divConstSecretResult").append("Share " + (i+1) + ":<b><input id='txtSharePart" + (i+1) + "' type='text'></b><br />");
						$("#txtSharePart" + (i+1)).val(share);
						shares.push(share);
					}
					
					
					var text = CreateInput(code.n, q);
					$("#divSecretInputs").html(text);
					$('#txtQ2').val(q);
				}
				else if (e.target.id == "btnFindSecret") {

					var q = parseInt($('#txtQ2').val());
					var processor = new MatrixCalculator(q);
					
					var text = $('#txtGeneratorMatrix').val();
					var arr = ReadMatrix(text);
					var generator = new Matrix(arr);
					var code = new ErrorCorrectingCode(generator, q);
					
					var indices = [];
					var values = [];
					$("[id^=txtInpt]").each(function() {
						var i = parseInt($(this).attr('num')) - 1;
						var value =  parseInt($(this).val());
						if (isNaN(value)) value = 0;
						indices.push(i);
						values.push(value);
					});
					
					
					var syndromes = code.Syndroms();
					var syndromText = "\\begin{array}{cc} Syndrom & Coset Leader \\\\ \\hline";
					for (var prop in syndromes) {
						// skip loop if the property is from prototype
						if(!syndromes.hasOwnProperty(prop)) continue;
						syndromText += prop + "&" + syndromes[prop].Text + "\\\\";
					}
					syndromText += "\\end{array}";

					
					var recived = new CodeWord(new Matrix(values));
					var synd = new CodeWord(processor.Multiply(recived.Data, code.DualCode().Generator.Transpose()));
					var error = syndromes[synd.Text];
					var corrected = new CodeWord(processor.Subtract(recived.Data, error.Data));
					
					var decodeList = {};
					for (var i = 0; i  < code.M; i++) {
						var word = code.GetWord(i);
						var codeword = code.CalculateCodeword(word);
						decodeList[codeword.Text] = word;
					}
					
					AddFormula("divFindSecretResult", "divMat_Result1",  syndromText);
					AddFormula("divFindSecretResult", "divMat_Result2", "recived=" + recived.Text);
					AddFormula("divFindSecretResult", "divMat_Result3", "syndrom=" + synd.Text);
					AddFormula("divFindSecretResult", "divMat_Result4", "error=" + error.Text);
					AddFormula("divFindSecretResult", "divMat_Result5", "corrected=" + corrected.Text);
					AddFormula("divFindSecretResult", "divMat_Result6", "s" + generator.ToLatex() + "=" + corrected.Data.ToLatex() );
					AddFormula("divFindSecretResult", "divMat_Result7", "s=" + decodeList[corrected.Text].Text );
					
					return;
					var t = vectors.length;

					var Mw = vectors[0];
					for (var i = 1; i  < t; i++)
						Mw = Mw.AddBottom(vectors[i]);
					var det = processor.Determinant(Mw);

					var y = new Matrix(values).Transpose();
					var textX = new MatrixGenerator().Pattern(t, 1, function(i,j) { return "x_{" + i + "}"; }).ToLatex();
					var textResult = Mw.ToLatex() + textX + "=" + y.ToLatex() + "\\\\Determinant= " + det;
					AddFormula("divFindSecretResult", "divMat_Result1", textResult);

					var X = processor.Solve(Mw, y);
					var textResult = "X=" + X.ToLatex();
					AddFormula("divFindSecretResult", "divMat_ResultX", textResult);

				}
				
			});
		});
	</script>

</body>

</html>
